/* UserManager.c generated by valac 0.56.14, the Vala compiler
 * generated from UserManager.vala, do not modify */

/*
 * Copyright (c) 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "session.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <act/act.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

#define SESSION_SERVICES_USER_MANAGER_GUEST_USER_UID ((guint) 999)
#define SESSION_SERVICES_USER_MANAGER_NOBODY_USER_UID ((guint) 65534)
#define SESSION_SERVICES_USER_MANAGER_RESERVED_UID_RANGE_END ((guint) 1000)
#define SESSION_SERVICES_USER_MANAGER_DM_DBUS_ID "org.freedesktop.DisplayManager"
#define SESSION_SERVICES_USER_MANAGER_LOGIN_IFACE "org.freedesktop.login1"
#define SESSION_SERVICES_USER_MANAGER_LOGIN_PATH "/org/freedesktop/login1"

#define TYPE_SEAT_INTERFACE (seat_interface_get_type ())
#define SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEAT_INTERFACE, SeatInterface))
#define IS_SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEAT_INTERFACE))
#define SEAT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SEAT_INTERFACE, SeatInterfaceIface))

typedef struct _SeatInterface SeatInterface;
typedef struct _SeatInterfaceIface SeatInterfaceIface;

#define TYPE_SEAT_INTERFACE_PROXY (seat_interface_proxy_get_type ())
enum  {
	SESSION_SERVICES_USER_MANAGER_0_PROPERTY,
	SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY,
	SESSION_SERVICES_USER_MANAGER_NUM_PROPERTIES
};
static GParamSpec* session_services_user_manager_properties[SESSION_SERVICES_USER_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SYSTEM_INTERFACE (system_interface_get_type ())
#define SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_INTERFACE, SystemInterface))
#define IS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_INTERFACE))
#define SYSTEM_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SYSTEM_INTERFACE, SystemInterfaceIface))

typedef struct _SystemInterface SystemInterface;
typedef struct _SystemInterfaceIface SystemInterfaceIface;

#define TYPE_SYSTEM_INTERFACE_PROXY (system_interface_proxy_get_type ())

#define TYPE_USER_INFO (user_info_get_type ())
typedef struct _UserInfo UserInfo;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SessionServicesUserManagerInitLoginProxyData SessionServicesUserManagerInitLoginProxyData;

#define TYPE_USER_INTERFACE (user_interface_get_type ())
#define USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_INTERFACE, UserInterface))
#define IS_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_INTERFACE))
#define USER_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_USER_INTERFACE, UserInterfaceIface))

typedef struct _UserInterface UserInterface;
typedef struct _UserInterfaceIface UserInterfaceIface;

#define TYPE_USER_INTERFACE_PROXY (user_interface_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SessionServicesUserManagerGetUserStateData SessionServicesUserManagerGetUserStateData;
typedef struct _SessionServicesUserManagerGetGuestStateData SessionServicesUserManagerGetGuestStateData;
typedef struct _SessionServicesUserManagerGetNActiveAndOnlineUsersData SessionServicesUserManagerGetNActiveAndOnlineUsersData;
typedef struct _Block4Data Block4Data;
enum  {
	SESSION_SERVICES_USER_MANAGER_CLOSE_SIGNAL,
	SESSION_SERVICES_USER_MANAGER_CHANGED_SIGNAL,
	SESSION_SERVICES_USER_MANAGER_NUM_SIGNALS
};
static guint session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_NUM_SIGNALS] = {0};

struct _SeatInterfaceIface {
	GTypeInterface parent_iface;
	void (*switch_to_guest) (SeatInterface* self, const gchar* session_name, GError** error);
	void (*switch_to_user) (SeatInterface* self, const gchar* username, const gchar* session_name, GError** error);
	gboolean (*get_has_guest_account) (SeatInterface* self);
};

struct _SessionServicesUserManagerPrivate {
	SessionWidgetsUserListBox* _user_grid;
	ActUserManager* manager;
	GeeHashMap* user_boxes;
	SeatInterface* dm_proxy;
};

struct _UserInfo {
	guint32 uid;
	gchar* user_name;
	char* user_object;
};

struct _SystemInterfaceIface {
	GTypeInterface parent_iface;
	void (*suspend) (SystemInterface* self, gboolean interactive, GError** error);
	void (*reboot) (SystemInterface* self, gboolean interactive, GError** error);
	void (*power_off) (SystemInterface* self, gboolean interactive, GError** error);
	UserInfo* (*list_users) (SystemInterface* self, gint* result_length1, GError** error);
};

struct _SessionServicesUserManagerInitLoginProxyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SystemInterface* _tmp0_;
	SystemInterface* _tmp1_;
	SystemInterface* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _UserInterfaceIface {
	GTypeInterface parent_iface;
	gchar* (*get_state) (UserInterface* self);
};

struct _SessionServicesUserManagerGetUserStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	guint32 uuid;
	UserState result;
	SystemInterface* _tmp0_;
	UserInfo* users;
	SystemInterface* _tmp1_;
	gint _tmp2_;
	UserInfo* _tmp3_;
	gint users_length1;
	gint _users_size_;
	UserInfo* _tmp4_;
	gint _tmp4__length1;
	UserInfo* _tmp5_;
	gint _tmp5__length1;
	UserInfo* user_collection;
	gint user_collection_length1;
	gint _user_collection_size_;
	gint user_it;
	UserInfo _tmp6_;
	UserInfo _tmp7_;
	UserInfo user;
	UserInfo _tmp8_;
	UserInfo _tmp9_;
	const char* _tmp10_;
	UserInterface* user_interface;
	UserInfo _tmp11_;
	const char* _tmp12_;
	UserInterface* _tmp13_;
	UserInterface* _tmp14_;
	UserInterface* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	UserState _tmp19_;
	GError* e;
	GError* _tmp20_;
	const gchar* _tmp21_;
	GError* _inner_error0_;
};

struct _SessionServicesUserManagerGetGuestStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UserState result;
	SystemInterface* _tmp0_;
	UserInfo* users;
	SystemInterface* _tmp1_;
	gint _tmp2_;
	UserInfo* _tmp3_;
	gint users_length1;
	gint _users_size_;
	UserInfo* _tmp4_;
	gint _tmp4__length1;
	UserInfo* user_collection;
	gint user_collection_length1;
	gint _user_collection_size_;
	gint user_it;
	UserInfo _tmp5_;
	UserInfo _tmp6_;
	UserInfo user;
	UserState state;
	UserInfo _tmp7_;
	gboolean _tmp8_;
	UserInfo _tmp9_;
	const gchar* _tmp10_;
	GError* e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _SessionServicesUserManagerGetNActiveAndOnlineUsersData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SessionServicesUserManager* self;
	gint result;
	gint n_active_and_online_users;
	ActUserManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ActUserManager* _tmp3_;
	GSList* _tmp4_;
	GSList* user_collection;
	GSList* user_it;
	ActUser* user;
	gboolean _tmp5_;
	ActUser* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ActUser* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	UserState state;
	ActUser* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gboolean _tmp15_;
	gint _tmp16_;
};

struct _Block4Data {
	int _ref_count_;
	SessionServicesUserManager* self;
	gchar* session_path;
};

static gint SessionServicesUserManager_private_offset;
static gpointer session_services_user_manager_parent_class = NULL;
static SystemInterface* session_services_user_manager_login_proxy;
static SystemInterface* session_services_user_manager_login_proxy = NULL;

VALA_EXTERN GType seat_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint seat_interface_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
VALA_EXTERN GType seat_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType system_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint system_interface_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
VALA_EXTERN GType user_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserInfo* user_info_dup (const UserInfo* self);
VALA_EXTERN void user_info_free (UserInfo* self);
VALA_EXTERN void user_info_copy (const UserInfo* self,
                     UserInfo* dest);
VALA_EXTERN void user_info_destroy (UserInfo* self);
VALA_EXTERN GType system_interface_get_type (void) G_GNUC_CONST ;
static void session_services_user_manager_init_login_proxy_data_free (gpointer _data);
static void session_services_user_manager_init_login_proxy (GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void session_services_user_manager_init_login_proxy_finish (GAsyncResult* _res_);
static gboolean session_services_user_manager_init_login_proxy_co (SessionServicesUserManagerInitLoginProxyData* _data_);
static void session_services_user_manager_init_login_proxy_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void session_services_user_manager_get_user_state_data_free (gpointer _data);
static gboolean session_services_user_manager_get_user_state_co (SessionServicesUserManagerGetUserStateData* _data_);
VALA_EXTERN UserInfo* system_interface_list_users (SystemInterface* self,
                                       gint* result_length1,
                                       GError** error);
static void _vala_UserInfo_array_free (UserInfo * array,
                                gssize array_length);
VALA_EXTERN GType user_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType user_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint user_interface_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
static void session_services_user_manager_get_user_state_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
VALA_EXTERN gchar* user_interface_get_state (UserInterface* self);
static void session_services_user_manager_get_guest_state_data_free (gpointer _data);
static gboolean session_services_user_manager_get_guest_state_co (SessionServicesUserManagerGetGuestStateData* _data_);
static void session_services_user_manager_get_guest_state_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void session_services_user_manager_init_users (SessionServicesUserManager* self);
static void session_services_user_manager_add_user (SessionServicesUserManager* self,
                                             ActUser* user);
static void session_services_user_manager_remove_user (SessionServicesUserManager* self,
                                                ActUser* user);
static void session_services_user_manager_update_user (SessionServicesUserManager* self,
                                                ActUser* user);
static void session_services_user_manager_add_guest (SessionServicesUserManager* self);
static void session_services_user_manager_get_n_active_and_online_users_data_free (gpointer _data);
static gboolean session_services_user_manager_get_n_active_and_online_users_co (SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_);
static void session_services_user_manager_get_n_active_and_online_users_ready (GObject* source_object,
                                                                        GAsyncResult* _res_,
                                                                        gpointer _user_data_);
static void session_services_user_manager_set_user_grid (SessionServicesUserManager* self,
                                                  SessionWidgetsUserListBox* value);
static GObject * session_services_user_manager_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _session_services_user_manager___lambda5_ (SessionServicesUserManager* self);
static void __session_services_user_manager___lambda5__session_widgets_user_list_box_close (SessionWidgetsUserListBox* _sender,
                                                                                     gpointer self);
static void _session_services_user_manager_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self);
static void _session_services_user_manager_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                               ActUser* user,
                                                                               gpointer self);
static void _session_services_user_manager_update_user_act_user_manager_user_is_logged_in_changed (ActUserManager* _sender,
                                                                                            ActUser* user,
                                                                                            gpointer self);
static void _session_services_user_manager___lambda6_ (SessionServicesUserManager* self);
static void __session_services_user_manager___lambda6__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
VALA_EXTERN gboolean seat_interface_get_has_guest_account (SeatInterface* self);
static void _session_services_user_manager____lambda7_ (SessionServicesUserManager* self);
VALA_EXTERN void seat_interface_switch_to_guest (SeatInterface* self,
                                     const gchar* session_name,
                                     GError** error);
static void __session_services_user_manager____lambda7__session_widgets_user_list_box_switch_to_guest (SessionWidgetsUserListBox* _sender,
                                                                                                gpointer self);
static void _session_services_user_manager____lambda8_ (Block4Data* _data4_,
                                                 const gchar* username);
VALA_EXTERN void seat_interface_switch_to_user (SeatInterface* self,
                                    const gchar* username,
                                    const gchar* session_name,
                                    GError** error);
static void __session_services_user_manager____lambda8__session_widgets_user_list_box_switch_to_user (SessionWidgetsUserListBox* _sender,
                                                                                               const gchar* username,
                                                                                               gpointer self);
static void session_services_user_manager_finalize (GObject * obj);
static GType session_services_user_manager_get_type_once (void);
static void _vala_session_services_user_manager_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_session_services_user_manager_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

UserState
user_state_to_enum (const gchar* state)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 26 "../src/Services/UserManager.vala"
	static GQuark _tmp1_label0 = 0;
#line 26 "../src/Services/UserManager.vala"
	static GQuark _tmp1_label1 = 0;
#line 380 "UserManager.c"
	UserState result;
#line 25 "../src/Services/UserManager.vala"
	g_return_val_if_fail (state != NULL, 0);
#line 26 "../src/Services/UserManager.vala"
	_tmp0_ = state;
#line 26 "../src/Services/UserManager.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 26 "../src/Services/UserManager.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("active")))) {
#line 26 "../src/Services/UserManager.vala"
		switch (0) {
#line 392 "UserManager.c"
			default:
			{
#line 28 "../src/Services/UserManager.vala"
				result = USER_STATE_ACTIVE;
#line 28 "../src/Services/UserManager.vala"
				return result;
#line 399 "UserManager.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("online")))) {
#line 26 "../src/Services/UserManager.vala"
		switch (0) {
#line 405 "UserManager.c"
			default:
			{
#line 30 "../src/Services/UserManager.vala"
				result = USER_STATE_ONLINE;
#line 30 "../src/Services/UserManager.vala"
				return result;
#line 412 "UserManager.c"
			}
		}
	}
#line 33 "../src/Services/UserManager.vala"
	result = USER_STATE_OFFLINE;
#line 33 "../src/Services/UserManager.vala"
	return result;
#line 420 "UserManager.c"
}

static GType
user_state_get_type_once (void)
{
	static const GEnumValue values[] = {{USER_STATE_ACTIVE, "USER_STATE_ACTIVE", "active"}, {USER_STATE_ONLINE, "USER_STATE_ONLINE", "online"}, {USER_STATE_OFFLINE, "USER_STATE_OFFLINE", "offline"}, {0, NULL, NULL}};
	GType user_state_type_id;
	user_state_type_id = g_enum_register_static ("UserState", values);
	return user_state_type_id;
}

GType
user_state_get_type (void)
{
	static volatile gsize user_state_type_id__once = 0;
	if (g_once_init_enter (&user_state_type_id__once)) {
		GType user_state_type_id;
		user_state_type_id = user_state_get_type_once ();
		g_once_init_leave (&user_state_type_id__once, user_state_type_id);
	}
	return user_state_type_id__once;
}

static inline gpointer
session_services_user_manager_get_instance_private (SessionServicesUserManager* self)
{
	return G_STRUCT_MEMBER_P (self, SessionServicesUserManager_private_offset);
}

static void
session_services_user_manager_init_login_proxy_data_free (gpointer _data)
{
	SessionServicesUserManagerInitLoginProxyData* _data_;
	_data_ = _data;
#line 37 "../src/Services/UserManager.vala"
	g_slice_free (SessionServicesUserManagerInitLoginProxyData, _data_);
#line 457 "UserManager.c"
}

static void
session_services_user_manager_init_login_proxy (GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	SessionServicesUserManagerInitLoginProxyData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_slice_new0 (SessionServicesUserManagerInitLoginProxyData);
#line 37 "../src/Services/UserManager.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 37 "../src/Services/UserManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_services_user_manager_init_login_proxy_data_free);
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_init_login_proxy_co (_data_);
#line 473 "UserManager.c"
}

static void
session_services_user_manager_init_login_proxy_finish (GAsyncResult* _res_)
{
	SessionServicesUserManagerInitLoginProxyData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 482 "UserManager.c"
}

static void
session_services_user_manager_init_login_proxy_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	SessionServicesUserManagerInitLoginProxyData* _data_;
#line 63 "../src/Services/UserManager.vala"
	_data_ = _user_data_;
#line 63 "../src/Services/UserManager.vala"
	_data_->_source_object_ = source_object;
#line 63 "../src/Services/UserManager.vala"
	_data_->_res_ = _res_;
#line 63 "../src/Services/UserManager.vala"
	session_services_user_manager_init_login_proxy_co (_data_);
#line 499 "UserManager.c"
}

static gboolean
session_services_user_manager_init_login_proxy_co (SessionServicesUserManagerInitLoginProxyData* _data_)
{
#line 61 "../src/Services/UserManager.vala"
	switch (_data_->_state_) {
#line 61 "../src/Services/UserManager.vala"
		case 0:
#line 509 "UserManager.c"
		goto _state_0;
#line 61 "../src/Services/UserManager.vala"
		case 1:
#line 513 "UserManager.c"
		goto _state_1;
		default:
#line 61 "../src/Services/UserManager.vala"
		g_assert_not_reached ();
#line 518 "UserManager.c"
	}
	_state_0:
	{
#line 63 "../src/Services/UserManager.vala"
		_data_->_state_ = 1;
#line 63 "../src/Services/UserManager.vala"
		g_async_initable_new_async (TYPE_SYSTEM_INTERFACE_PROXY, 0, NULL, session_services_user_manager_init_login_proxy_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", SESSION_SERVICES_USER_MANAGER_LOGIN_IFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", SESSION_SERVICES_USER_MANAGER_LOGIN_PATH, "g-interface-name", "org.freedesktop.login1.Manager", NULL);
#line 63 "../src/Services/UserManager.vala"
		return FALSE;
#line 528 "UserManager.c"
		_state_1:
#line 63 "../src/Services/UserManager.vala"
		_data_->_tmp1_ = (SystemInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 63 "../src/Services/UserManager.vala"
		_data_->_tmp0_ = (SystemInterface*) _data_->_tmp1_;
#line 63 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/Services/UserManager.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 538 "UserManager.c"
				goto __catch0_g_io_error;
			}
#line 63 "../src/Services/UserManager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 63 "../src/Services/UserManager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 63 "../src/Services/UserManager.vala"
			g_object_unref (_data_->_async_result);
#line 63 "../src/Services/UserManager.vala"
			return FALSE;
#line 549 "UserManager.c"
		}
#line 63 "../src/Services/UserManager.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 63 "../src/Services/UserManager.vala"
		_data_->_tmp0_ = NULL;
#line 63 "../src/Services/UserManager.vala"
		_g_object_unref0 (session_services_user_manager_login_proxy);
#line 63 "../src/Services/UserManager.vala"
		session_services_user_manager_login_proxy = _data_->_tmp2_;
#line 62 "../src/Services/UserManager.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 561 "UserManager.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 62 "../src/Services/UserManager.vala"
		_data_->e = _data_->_inner_error0_;
#line 62 "../src/Services/UserManager.vala"
		_data_->_inner_error0_ = NULL;
#line 65 "../src/Services/UserManager.vala"
		_data_->_tmp3_ = _data_->e;
#line 65 "../src/Services/UserManager.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 65 "../src/Services/UserManager.vala"
		g_critical ("UserManager.vala:65: Failed to create login1 dbus proxy: %s", _data_->_tmp4_);
#line 62 "../src/Services/UserManager.vala"
		_g_error_free0 (_data_->e);
#line 578 "UserManager.c"
	}
	__finally0:
#line 62 "../src/Services/UserManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 62 "../src/Services/UserManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 62 "../src/Services/UserManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 62 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 62 "../src/Services/UserManager.vala"
		return FALSE;
#line 591 "UserManager.c"
	}
#line 61 "../src/Services/UserManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 61 "../src/Services/UserManager.vala"
	if (_data_->_state_ != 0) {
#line 61 "../src/Services/UserManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 61 "../src/Services/UserManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 601 "UserManager.c"
		}
	}
#line 61 "../src/Services/UserManager.vala"
	g_object_unref (_data_->_async_result);
#line 61 "../src/Services/UserManager.vala"
	return FALSE;
#line 608 "UserManager.c"
}

static void
session_services_user_manager_get_user_state_data_free (gpointer _data)
{
	SessionServicesUserManagerGetUserStateData* _data_;
	_data_ = _data;
#line 37 "../src/Services/UserManager.vala"
	g_slice_free (SessionServicesUserManagerGetUserStateData, _data_);
#line 618 "UserManager.c"
}

void
session_services_user_manager_get_user_state (guint32 uuid,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SessionServicesUserManagerGetUserStateData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_slice_new0 (SessionServicesUserManagerGetUserStateData);
#line 37 "../src/Services/UserManager.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 37 "../src/Services/UserManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_services_user_manager_get_user_state_data_free);
#line 37 "../src/Services/UserManager.vala"
	_data_->uuid = uuid;
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_get_user_state_co (_data_);
#line 637 "UserManager.c"
}

UserState
session_services_user_manager_get_user_state_finish (GAsyncResult* _res_)
{
	UserState result;
	SessionServicesUserManagerGetUserStateData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 37 "../src/Services/UserManager.vala"
	result = _data_->result;
#line 37 "../src/Services/UserManager.vala"
	return result;
#line 651 "UserManager.c"
}

static void
_vala_UserInfo_array_free (UserInfo * array,
                           gssize array_length)
{
#line 77 "../src/Services/UserManager.vala"
	if (array != NULL) {
#line 660 "UserManager.c"
		gssize i;
#line 77 "../src/Services/UserManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 77 "../src/Services/UserManager.vala"
			user_info_destroy (&array[i]);
#line 666 "UserManager.c"
		}
	}
#line 77 "../src/Services/UserManager.vala"
	g_free (array);
#line 671 "UserManager.c"
}

static void
session_services_user_manager_get_user_state_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SessionServicesUserManagerGetUserStateData* _data_;
#line 85 "../src/Services/UserManager.vala"
	_data_ = _user_data_;
#line 85 "../src/Services/UserManager.vala"
	_data_->_source_object_ = source_object;
#line 85 "../src/Services/UserManager.vala"
	_data_->_res_ = _res_;
#line 85 "../src/Services/UserManager.vala"
	session_services_user_manager_get_user_state_co (_data_);
#line 688 "UserManager.c"
}

static gboolean
session_services_user_manager_get_user_state_co (SessionServicesUserManagerGetUserStateData* _data_)
{
#line 69 "../src/Services/UserManager.vala"
	switch (_data_->_state_) {
#line 69 "../src/Services/UserManager.vala"
		case 0:
#line 698 "UserManager.c"
		goto _state_0;
#line 69 "../src/Services/UserManager.vala"
		case 1:
#line 702 "UserManager.c"
		goto _state_1;
		default:
#line 69 "../src/Services/UserManager.vala"
		g_assert_not_reached ();
#line 707 "UserManager.c"
	}
	_state_0:
#line 70 "../src/Services/UserManager.vala"
	_data_->_tmp0_ = session_services_user_manager_login_proxy;
#line 70 "../src/Services/UserManager.vala"
	if (_data_->_tmp0_ == NULL) {
#line 71 "../src/Services/UserManager.vala"
		_data_->result = USER_STATE_OFFLINE;
#line 71 "../src/Services/UserManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 71 "../src/Services/UserManager.vala"
		if (_data_->_state_ != 0) {
#line 71 "../src/Services/UserManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 71 "../src/Services/UserManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 724 "UserManager.c"
			}
		}
#line 71 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 71 "../src/Services/UserManager.vala"
		return FALSE;
#line 731 "UserManager.c"
	}
	{
#line 75 "../src/Services/UserManager.vala"
		_data_->_tmp1_ = session_services_user_manager_login_proxy;
#line 75 "../src/Services/UserManager.vala"
		_data_->_tmp2_ = 0;
#line 75 "../src/Services/UserManager.vala"
		_data_->_tmp3_ = system_interface_list_users (_data_->_tmp1_, &_data_->_tmp2_, &_data_->_inner_error0_);
#line 75 "../src/Services/UserManager.vala"
		_data_->users = _data_->_tmp3_;
#line 75 "../src/Services/UserManager.vala"
		_data_->users_length1 = _data_->_tmp2_;
#line 75 "../src/Services/UserManager.vala"
		_data_->_users_size_ = _data_->users_length1;
#line 75 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 748 "UserManager.c"
			goto __catch0_g_error;
		}
#line 76 "../src/Services/UserManager.vala"
		_data_->_tmp4_ = _data_->users;
#line 76 "../src/Services/UserManager.vala"
		_data_->_tmp4__length1 = _data_->users_length1;
#line 76 "../src/Services/UserManager.vala"
		if (_data_->_tmp4_ == NULL) {
#line 77 "../src/Services/UserManager.vala"
			_data_->result = USER_STATE_OFFLINE;
#line 77 "../src/Services/UserManager.vala"
			_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 77 "../src/Services/UserManager.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 77 "../src/Services/UserManager.vala"
			if (_data_->_state_ != 0) {
#line 77 "../src/Services/UserManager.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 77 "../src/Services/UserManager.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 769 "UserManager.c"
				}
			}
#line 77 "../src/Services/UserManager.vala"
			g_object_unref (_data_->_async_result);
#line 77 "../src/Services/UserManager.vala"
			return FALSE;
#line 776 "UserManager.c"
		}
#line 80 "../src/Services/UserManager.vala"
		_data_->_tmp5_ = _data_->users;
#line 80 "../src/Services/UserManager.vala"
		_data_->_tmp5__length1 = _data_->users_length1;
#line 782 "UserManager.c"
		{
#line 80 "../src/Services/UserManager.vala"
			_data_->user_collection_length1 = 0;
#line 80 "../src/Services/UserManager.vala"
			_data_->_user_collection_size_ = 0;
#line 80 "../src/Services/UserManager.vala"
			_data_->user_collection = _data_->_tmp5_;
#line 80 "../src/Services/UserManager.vala"
			_data_->user_collection_length1 = _data_->_tmp5__length1;
#line 80 "../src/Services/UserManager.vala"
			for (_data_->user_it = 0; _data_->user_it < _data_->user_collection_length1; _data_->user_it = _data_->user_it + 1) {
#line 80 "../src/Services/UserManager.vala"
				_data_->_tmp6_ = _data_->user_collection[_data_->user_it];
#line 80 "../src/Services/UserManager.vala"
				memset (&_data_->_tmp7_, 0, sizeof (UserInfo));
#line 80 "../src/Services/UserManager.vala"
				user_info_copy (&_data_->_tmp6_, &_data_->_tmp7_);
#line 80 "../src/Services/UserManager.vala"
				_data_->user = _data_->_tmp7_;
#line 802 "UserManager.c"
				{
#line 81 "../src/Services/UserManager.vala"
					_data_->_tmp8_ = _data_->user;
#line 81 "../src/Services/UserManager.vala"
					if (_data_->_tmp8_.uid == _data_->uuid) {
#line 82 "../src/Services/UserManager.vala"
						_data_->_tmp9_ = _data_->user;
#line 82 "../src/Services/UserManager.vala"
						_data_->_tmp10_ = _data_->_tmp9_.user_object;
#line 82 "../src/Services/UserManager.vala"
						if (_data_->_tmp10_ == NULL) {
#line 83 "../src/Services/UserManager.vala"
							_data_->result = USER_STATE_OFFLINE;
#line 83 "../src/Services/UserManager.vala"
							user_info_destroy (&_data_->user);
#line 83 "../src/Services/UserManager.vala"
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 83 "../src/Services/UserManager.vala"
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 83 "../src/Services/UserManager.vala"
							if (_data_->_state_ != 0) {
#line 83 "../src/Services/UserManager.vala"
								while (!g_task_get_completed (_data_->_async_result)) {
#line 83 "../src/Services/UserManager.vala"
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 828 "UserManager.c"
								}
							}
#line 83 "../src/Services/UserManager.vala"
							g_object_unref (_data_->_async_result);
#line 83 "../src/Services/UserManager.vala"
							return FALSE;
#line 835 "UserManager.c"
						}
#line 85 "../src/Services/UserManager.vala"
						_data_->_tmp11_ = _data_->user;
#line 85 "../src/Services/UserManager.vala"
						_data_->_tmp12_ = _data_->_tmp11_.user_object;
#line 85 "../src/Services/UserManager.vala"
						_data_->_state_ = 1;
#line 85 "../src/Services/UserManager.vala"
						g_async_initable_new_async (TYPE_USER_INTERFACE_PROXY, 0, NULL, session_services_user_manager_get_user_state_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", SESSION_SERVICES_USER_MANAGER_LOGIN_IFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _data_->_tmp12_, "g-interface-name", "org.freedesktop.login1.User", NULL);
#line 85 "../src/Services/UserManager.vala"
						return FALSE;
#line 847 "UserManager.c"
						_state_1:
#line 85 "../src/Services/UserManager.vala"
						_data_->_tmp13_ = (UserInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 85 "../src/Services/UserManager.vala"
						_data_->user_interface = (UserInterface*) _data_->_tmp13_;
#line 85 "../src/Services/UserManager.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 85 "../src/Services/UserManager.vala"
							user_info_destroy (&_data_->user);
#line 85 "../src/Services/UserManager.vala"
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 859 "UserManager.c"
							goto __catch0_g_error;
						}
#line 86 "../src/Services/UserManager.vala"
						_data_->_tmp14_ = _data_->user_interface;
#line 86 "../src/Services/UserManager.vala"
						if (_data_->_tmp14_ == NULL) {
#line 87 "../src/Services/UserManager.vala"
							_data_->result = USER_STATE_OFFLINE;
#line 87 "../src/Services/UserManager.vala"
							_g_object_unref0 (_data_->user_interface);
#line 87 "../src/Services/UserManager.vala"
							user_info_destroy (&_data_->user);
#line 87 "../src/Services/UserManager.vala"
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 87 "../src/Services/UserManager.vala"
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 87 "../src/Services/UserManager.vala"
							if (_data_->_state_ != 0) {
#line 87 "../src/Services/UserManager.vala"
								while (!g_task_get_completed (_data_->_async_result)) {
#line 87 "../src/Services/UserManager.vala"
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 882 "UserManager.c"
								}
							}
#line 87 "../src/Services/UserManager.vala"
							g_object_unref (_data_->_async_result);
#line 87 "../src/Services/UserManager.vala"
							return FALSE;
#line 889 "UserManager.c"
						}
#line 89 "../src/Services/UserManager.vala"
						_data_->_tmp15_ = _data_->user_interface;
#line 89 "../src/Services/UserManager.vala"
						_data_->_tmp16_ = user_interface_get_state (_data_->_tmp15_);
#line 89 "../src/Services/UserManager.vala"
						_data_->_tmp17_ = _data_->_tmp16_;
#line 89 "../src/Services/UserManager.vala"
						_data_->_tmp18_ = _data_->_tmp17_;
#line 89 "../src/Services/UserManager.vala"
						_data_->_tmp19_ = user_state_to_enum (_data_->_tmp18_);
#line 89 "../src/Services/UserManager.vala"
						_g_free0 (_data_->_tmp18_);
#line 89 "../src/Services/UserManager.vala"
						_data_->result = _data_->_tmp19_;
#line 89 "../src/Services/UserManager.vala"
						_g_object_unref0 (_data_->user_interface);
#line 89 "../src/Services/UserManager.vala"
						user_info_destroy (&_data_->user);
#line 89 "../src/Services/UserManager.vala"
						_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 89 "../src/Services/UserManager.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 89 "../src/Services/UserManager.vala"
						if (_data_->_state_ != 0) {
#line 89 "../src/Services/UserManager.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 89 "../src/Services/UserManager.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 919 "UserManager.c"
							}
						}
#line 89 "../src/Services/UserManager.vala"
						g_object_unref (_data_->_async_result);
#line 89 "../src/Services/UserManager.vala"
						return FALSE;
#line 926 "UserManager.c"
					}
#line 80 "../src/Services/UserManager.vala"
					user_info_destroy (&_data_->user);
#line 930 "UserManager.c"
				}
			}
		}
#line 74 "../src/Services/UserManager.vala"
		_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 936 "UserManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 74 "../src/Services/UserManager.vala"
		_data_->e = _data_->_inner_error0_;
#line 74 "../src/Services/UserManager.vala"
		_data_->_inner_error0_ = NULL;
#line 94 "../src/Services/UserManager.vala"
		_data_->_tmp20_ = _data_->e;
#line 94 "../src/Services/UserManager.vala"
		_data_->_tmp21_ = _data_->_tmp20_->message;
#line 94 "../src/Services/UserManager.vala"
		g_critical ("UserManager.vala:94: Failed to get user state: %s", _data_->_tmp21_);
#line 74 "../src/Services/UserManager.vala"
		_g_error_free0 (_data_->e);
#line 953 "UserManager.c"
	}
	__finally0:
#line 74 "../src/Services/UserManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 74 "../src/Services/UserManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 74 "../src/Services/UserManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 74 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 74 "../src/Services/UserManager.vala"
		return FALSE;
#line 966 "UserManager.c"
	}
#line 97 "../src/Services/UserManager.vala"
	_data_->result = USER_STATE_OFFLINE;
#line 97 "../src/Services/UserManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 97 "../src/Services/UserManager.vala"
	if (_data_->_state_ != 0) {
#line 97 "../src/Services/UserManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 97 "../src/Services/UserManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 978 "UserManager.c"
		}
	}
#line 97 "../src/Services/UserManager.vala"
	g_object_unref (_data_->_async_result);
#line 97 "../src/Services/UserManager.vala"
	return FALSE;
#line 985 "UserManager.c"
}

static void
session_services_user_manager_get_guest_state_data_free (gpointer _data)
{
	SessionServicesUserManagerGetGuestStateData* _data_;
	_data_ = _data;
#line 37 "../src/Services/UserManager.vala"
	g_slice_free (SessionServicesUserManagerGetGuestStateData, _data_);
#line 995 "UserManager.c"
}

void
session_services_user_manager_get_guest_state (GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	SessionServicesUserManagerGetGuestStateData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_slice_new0 (SessionServicesUserManagerGetGuestStateData);
#line 37 "../src/Services/UserManager.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 37 "../src/Services/UserManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_services_user_manager_get_guest_state_data_free);
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_get_guest_state_co (_data_);
#line 1011 "UserManager.c"
}

UserState
session_services_user_manager_get_guest_state_finish (GAsyncResult* _res_)
{
	UserState result;
	SessionServicesUserManagerGetGuestStateData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 37 "../src/Services/UserManager.vala"
	result = _data_->result;
#line 37 "../src/Services/UserManager.vala"
	return result;
#line 1025 "UserManager.c"
}

static void
session_services_user_manager_get_guest_state_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	SessionServicesUserManagerGetGuestStateData* _data_;
#line 108 "../src/Services/UserManager.vala"
	_data_ = _user_data_;
#line 108 "../src/Services/UserManager.vala"
	_data_->_source_object_ = source_object;
#line 108 "../src/Services/UserManager.vala"
	_data_->_res_ = _res_;
#line 108 "../src/Services/UserManager.vala"
	session_services_user_manager_get_guest_state_co (_data_);
#line 1042 "UserManager.c"
}

static gboolean
session_services_user_manager_get_guest_state_co (SessionServicesUserManagerGetGuestStateData* _data_)
{
#line 100 "../src/Services/UserManager.vala"
	switch (_data_->_state_) {
#line 100 "../src/Services/UserManager.vala"
		case 0:
#line 1052 "UserManager.c"
		goto _state_0;
#line 100 "../src/Services/UserManager.vala"
		case 1:
#line 1056 "UserManager.c"
		goto _state_1;
		default:
#line 100 "../src/Services/UserManager.vala"
		g_assert_not_reached ();
#line 1061 "UserManager.c"
	}
	_state_0:
#line 101 "../src/Services/UserManager.vala"
	_data_->_tmp0_ = session_services_user_manager_login_proxy;
#line 101 "../src/Services/UserManager.vala"
	if (_data_->_tmp0_ == NULL) {
#line 102 "../src/Services/UserManager.vala"
		_data_->result = USER_STATE_OFFLINE;
#line 102 "../src/Services/UserManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 102 "../src/Services/UserManager.vala"
		if (_data_->_state_ != 0) {
#line 102 "../src/Services/UserManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 102 "../src/Services/UserManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1078 "UserManager.c"
			}
		}
#line 102 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 102 "../src/Services/UserManager.vala"
		return FALSE;
#line 1085 "UserManager.c"
	}
	{
#line 106 "../src/Services/UserManager.vala"
		_data_->_tmp1_ = session_services_user_manager_login_proxy;
#line 106 "../src/Services/UserManager.vala"
		_data_->_tmp2_ = 0;
#line 106 "../src/Services/UserManager.vala"
		_data_->_tmp3_ = system_interface_list_users (_data_->_tmp1_, &_data_->_tmp2_, &_data_->_inner_error0_);
#line 106 "../src/Services/UserManager.vala"
		_data_->users = _data_->_tmp3_;
#line 106 "../src/Services/UserManager.vala"
		_data_->users_length1 = _data_->_tmp2_;
#line 106 "../src/Services/UserManager.vala"
		_data_->_users_size_ = _data_->users_length1;
#line 106 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1102 "UserManager.c"
			goto __catch0_g_error;
		}
#line 107 "../src/Services/UserManager.vala"
		_data_->_tmp4_ = _data_->users;
#line 107 "../src/Services/UserManager.vala"
		_data_->_tmp4__length1 = _data_->users_length1;
#line 1109 "UserManager.c"
		{
#line 107 "../src/Services/UserManager.vala"
			_data_->user_collection_length1 = 0;
#line 107 "../src/Services/UserManager.vala"
			_data_->_user_collection_size_ = 0;
#line 107 "../src/Services/UserManager.vala"
			_data_->user_collection = _data_->_tmp4_;
#line 107 "../src/Services/UserManager.vala"
			_data_->user_collection_length1 = _data_->_tmp4__length1;
#line 107 "../src/Services/UserManager.vala"
			for (_data_->user_it = 0; _data_->user_it < _data_->user_collection_length1; _data_->user_it = _data_->user_it + 1) {
#line 107 "../src/Services/UserManager.vala"
				_data_->_tmp5_ = _data_->user_collection[_data_->user_it];
#line 107 "../src/Services/UserManager.vala"
				memset (&_data_->_tmp6_, 0, sizeof (UserInfo));
#line 107 "../src/Services/UserManager.vala"
				user_info_copy (&_data_->_tmp5_, &_data_->_tmp6_);
#line 107 "../src/Services/UserManager.vala"
				_data_->user = _data_->_tmp6_;
#line 1129 "UserManager.c"
				{
#line 108 "../src/Services/UserManager.vala"
					_data_->_tmp7_ = _data_->user;
#line 108 "../src/Services/UserManager.vala"
					_data_->_state_ = 1;
#line 108 "../src/Services/UserManager.vala"
					session_services_user_manager_get_user_state (_data_->_tmp7_.uid, session_services_user_manager_get_guest_state_ready, _data_);
#line 108 "../src/Services/UserManager.vala"
					return FALSE;
#line 1139 "UserManager.c"
					_state_1:
#line 108 "../src/Services/UserManager.vala"
					_data_->state = session_services_user_manager_get_user_state_finish (_data_->_res_);
#line 109 "../src/Services/UserManager.vala"
					_data_->_tmp9_ = _data_->user;
#line 109 "../src/Services/UserManager.vala"
					_data_->_tmp10_ = _data_->_tmp9_.user_name;
#line 109 "../src/Services/UserManager.vala"
					if (g_str_has_prefix (_data_->_tmp10_, "guest-")) {
#line 110 "../src/Services/UserManager.vala"
						_data_->_tmp8_ = _data_->state == USER_STATE_ACTIVE;
#line 1151 "UserManager.c"
					} else {
#line 109 "../src/Services/UserManager.vala"
						_data_->_tmp8_ = FALSE;
#line 1155 "UserManager.c"
					}
#line 109 "../src/Services/UserManager.vala"
					if (_data_->_tmp8_) {
#line 111 "../src/Services/UserManager.vala"
						_data_->result = USER_STATE_ACTIVE;
#line 111 "../src/Services/UserManager.vala"
						user_info_destroy (&_data_->user);
#line 111 "../src/Services/UserManager.vala"
						_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 111 "../src/Services/UserManager.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 111 "../src/Services/UserManager.vala"
						if (_data_->_state_ != 0) {
#line 111 "../src/Services/UserManager.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 111 "../src/Services/UserManager.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1173 "UserManager.c"
							}
						}
#line 111 "../src/Services/UserManager.vala"
						g_object_unref (_data_->_async_result);
#line 111 "../src/Services/UserManager.vala"
						return FALSE;
#line 1180 "UserManager.c"
					}
#line 107 "../src/Services/UserManager.vala"
					user_info_destroy (&_data_->user);
#line 1184 "UserManager.c"
				}
			}
		}
#line 105 "../src/Services/UserManager.vala"
		_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
#line 1190 "UserManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 105 "../src/Services/UserManager.vala"
		_data_->e = _data_->_inner_error0_;
#line 105 "../src/Services/UserManager.vala"
		_data_->_inner_error0_ = NULL;
#line 115 "../src/Services/UserManager.vala"
		_data_->_tmp11_ = _data_->e;
#line 115 "../src/Services/UserManager.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 115 "../src/Services/UserManager.vala"
		g_critical ("UserManager.vala:115: Failed to get Guest state: %s", _data_->_tmp12_);
#line 105 "../src/Services/UserManager.vala"
		_g_error_free0 (_data_->e);
#line 1207 "UserManager.c"
	}
	__finally0:
#line 105 "../src/Services/UserManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 105 "../src/Services/UserManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 105 "../src/Services/UserManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 105 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 105 "../src/Services/UserManager.vala"
		return FALSE;
#line 1220 "UserManager.c"
	}
#line 118 "../src/Services/UserManager.vala"
	_data_->result = USER_STATE_OFFLINE;
#line 118 "../src/Services/UserManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 118 "../src/Services/UserManager.vala"
	if (_data_->_state_ != 0) {
#line 118 "../src/Services/UserManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 118 "../src/Services/UserManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1232 "UserManager.c"
		}
	}
#line 118 "../src/Services/UserManager.vala"
	g_object_unref (_data_->_async_result);
#line 118 "../src/Services/UserManager.vala"
	return FALSE;
#line 1239 "UserManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 176 "../src/Services/UserManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1247 "UserManager.c"
}

static void
session_services_user_manager_init_users (SessionServicesUserManager* self)
{
	ActUserManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ActUserManager* _tmp3_;
	GSList* _tmp4_;
#line 171 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/Services/UserManager.vala"
	_tmp0_ = self->priv->manager;
#line 172 "../src/Services/UserManager.vala"
	g_object_get (_tmp0_, "is-loaded", &_tmp1_, NULL);
#line 172 "../src/Services/UserManager.vala"
	_tmp2_ = _tmp1_;
#line 172 "../src/Services/UserManager.vala"
	if (!_tmp2_) {
#line 173 "../src/Services/UserManager.vala"
		return;
#line 1270 "UserManager.c"
	}
#line 176 "../src/Services/UserManager.vala"
	_tmp3_ = self->priv->manager;
#line 176 "../src/Services/UserManager.vala"
	_tmp4_ = act_user_manager_list_users (_tmp3_);
#line 1276 "UserManager.c"
	{
		GSList* user_collection = NULL;
		GSList* user_it = NULL;
#line 176 "../src/Services/UserManager.vala"
		user_collection = _tmp4_;
#line 176 "../src/Services/UserManager.vala"
		for (user_it = user_collection; user_it != NULL; user_it = user_it->next) {
#line 1284 "UserManager.c"
			ActUser* _tmp5_;
			ActUser* user = NULL;
#line 176 "../src/Services/UserManager.vala"
			_tmp5_ = _g_object_ref0 ((ActUser*) user_it->data);
#line 176 "../src/Services/UserManager.vala"
			user = _tmp5_;
#line 1291 "UserManager.c"
			{
				ActUser* _tmp6_;
#line 177 "../src/Services/UserManager.vala"
				_tmp6_ = user;
#line 177 "../src/Services/UserManager.vala"
				session_services_user_manager_add_user (self, _tmp6_);
#line 176 "../src/Services/UserManager.vala"
				_g_object_unref0 (user);
#line 1300 "UserManager.c"
			}
		}
#line 176 "../src/Services/UserManager.vala"
		(user_collection == NULL) ? NULL : (user_collection = (g_slist_free (user_collection), NULL));
#line 1305 "UserManager.c"
	}
}

static void
session_services_user_manager_add_user (SessionServicesUserManager* self,
                                        ActUser* user)
{
	guint uid = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeHashMap* _tmp3_;
	SessionWidgetsUserbox* _tmp4_;
	SessionWidgetsUserbox* _tmp5_;
	SessionWidgetsUserListBox* _tmp6_;
	GeeHashMap* _tmp7_;
	gpointer _tmp8_;
	SessionWidgetsUserbox* _tmp9_;
#line 181 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Services/UserManager.vala"
	uid = act_user_get_uid (user);
#line 184 "../src/Services/UserManager.vala"
	if (uid < SESSION_SERVICES_USER_MANAGER_RESERVED_UID_RANGE_END) {
#line 184 "../src/Services/UserManager.vala"
		_tmp1_ = TRUE;
#line 1331 "UserManager.c"
	} else {
#line 184 "../src/Services/UserManager.vala"
		_tmp1_ = uid == SESSION_SERVICES_USER_MANAGER_NOBODY_USER_UID;
#line 1335 "UserManager.c"
	}
#line 184 "../src/Services/UserManager.vala"
	if (_tmp1_) {
#line 184 "../src/Services/UserManager.vala"
		_tmp0_ = TRUE;
#line 1341 "UserManager.c"
	} else {
		GeeHashMap* _tmp2_;
#line 184 "../src/Services/UserManager.vala"
		_tmp2_ = self->priv->user_boxes;
#line 184 "../src/Services/UserManager.vala"
		_tmp0_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) uid));
#line 1348 "UserManager.c"
	}
#line 184 "../src/Services/UserManager.vala"
	if (_tmp0_) {
#line 185 "../src/Services/UserManager.vala"
		return;
#line 1354 "UserManager.c"
	}
#line 188 "../src/Services/UserManager.vala"
	_tmp3_ = self->priv->user_boxes;
#line 188 "../src/Services/UserManager.vala"
	_tmp4_ = session_widgets_userbox_new (user);
#line 188 "../src/Services/UserManager.vala"
	g_object_ref_sink (_tmp4_);
#line 188 "../src/Services/UserManager.vala"
	_tmp5_ = _tmp4_;
#line 188 "../src/Services/UserManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((guintptr) uid), _tmp5_);
#line 188 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp5_);
#line 189 "../src/Services/UserManager.vala"
	_tmp6_ = self->priv->_user_grid;
#line 189 "../src/Services/UserManager.vala"
	_tmp7_ = self->priv->user_boxes;
#line 189 "../src/Services/UserManager.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) uid));
#line 189 "../src/Services/UserManager.vala"
	_tmp9_ = (SessionWidgetsUserbox*) _tmp8_;
#line 189 "../src/Services/UserManager.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp9_);
#line 189 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp9_);
#line 191 "../src/Services/UserManager.vala"
	g_signal_emit (self, session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CHANGED_SIGNAL], 0);
#line 1382 "UserManager.c"
}

static void
session_services_user_manager_remove_user (SessionServicesUserManager* self,
                                           ActUser* user)
{
	guint uid = 0U;
	SessionWidgetsUserbox* userbox = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SessionWidgetsUserbox* _tmp2_;
	GeeHashMap* _tmp3_;
	SessionWidgetsUserListBox* _tmp4_;
	SessionWidgetsUserbox* _tmp5_;
#line 194 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/Services/UserManager.vala"
	g_return_if_fail (user != NULL);
#line 195 "../src/Services/UserManager.vala"
	uid = act_user_get_uid (user);
#line 196 "../src/Services/UserManager.vala"
	_tmp0_ = self->priv->user_boxes;
#line 196 "../src/Services/UserManager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) uid));
#line 196 "../src/Services/UserManager.vala"
	userbox = (SessionWidgetsUserbox*) _tmp1_;
#line 197 "../src/Services/UserManager.vala"
	_tmp2_ = userbox;
#line 197 "../src/Services/UserManager.vala"
	if (_tmp2_ == NULL) {
#line 198 "../src/Services/UserManager.vala"
		_g_object_unref0 (userbox);
#line 198 "../src/Services/UserManager.vala"
		return;
#line 1417 "UserManager.c"
	}
#line 201 "../src/Services/UserManager.vala"
	_tmp3_ = self->priv->user_boxes;
#line 201 "../src/Services/UserManager.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (gpointer) ((guintptr) uid), NULL);
#line 202 "../src/Services/UserManager.vala"
	_tmp4_ = self->priv->_user_grid;
#line 202 "../src/Services/UserManager.vala"
	_tmp5_ = userbox;
#line 202 "../src/Services/UserManager.vala"
	gtk_container_remove ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 203 "../src/Services/UserManager.vala"
	g_signal_emit (self, session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CHANGED_SIGNAL], 0);
#line 194 "../src/Services/UserManager.vala"
	_g_object_unref0 (userbox);
#line 1433 "UserManager.c"
}

static void
session_services_user_manager_update_user (SessionServicesUserManager* self,
                                           ActUser* user)
{
	SessionWidgetsUserbox* userbox = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SessionWidgetsUserbox* _tmp2_;
	SessionWidgetsUserbox* _tmp3_;
#line 206 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Services/UserManager.vala"
	g_return_if_fail (user != NULL);
#line 207 "../src/Services/UserManager.vala"
	_tmp0_ = self->priv->user_boxes;
#line 207 "../src/Services/UserManager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) act_user_get_uid (user)));
#line 207 "../src/Services/UserManager.vala"
	userbox = (SessionWidgetsUserbox*) _tmp1_;
#line 208 "../src/Services/UserManager.vala"
	_tmp2_ = userbox;
#line 208 "../src/Services/UserManager.vala"
	if (_tmp2_ == NULL) {
#line 209 "../src/Services/UserManager.vala"
		_g_object_unref0 (userbox);
#line 209 "../src/Services/UserManager.vala"
		return;
#line 1463 "UserManager.c"
	}
#line 212 "../src/Services/UserManager.vala"
	_tmp3_ = userbox;
#line 212 "../src/Services/UserManager.vala"
	session_widgets_userbox_update_state (_tmp3_, NULL, NULL);
#line 213 "../src/Services/UserManager.vala"
	g_signal_emit (self, session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CHANGED_SIGNAL], 0);
#line 206 "../src/Services/UserManager.vala"
	_g_object_unref0 (userbox);
#line 1473 "UserManager.c"
}

void
session_services_user_manager_update_all (SessionServicesUserManager* self)
{
#line 216 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 1481 "UserManager.c"
	{
		GeeIterator* _userbox_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 217 "../src/Services/UserManager.vala"
		_tmp0_ = self->priv->user_boxes;
#line 217 "../src/Services/UserManager.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 217 "../src/Services/UserManager.vala"
		_tmp2_ = _tmp1_;
#line 217 "../src/Services/UserManager.vala"
		_tmp3_ = _tmp2_;
#line 217 "../src/Services/UserManager.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 217 "../src/Services/UserManager.vala"
		_tmp5_ = _tmp4_;
#line 217 "../src/Services/UserManager.vala"
		_g_object_unref0 (_tmp3_);
#line 217 "../src/Services/UserManager.vala"
		_userbox_it = _tmp5_;
#line 217 "../src/Services/UserManager.vala"
		while (TRUE) {
#line 1508 "UserManager.c"
			GeeIterator* _tmp6_;
			SessionWidgetsUserbox* userbox = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			SessionWidgetsUserbox* _tmp9_;
#line 217 "../src/Services/UserManager.vala"
			_tmp6_ = _userbox_it;
#line 217 "../src/Services/UserManager.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 217 "../src/Services/UserManager.vala"
				break;
#line 1520 "UserManager.c"
			}
#line 217 "../src/Services/UserManager.vala"
			_tmp7_ = _userbox_it;
#line 217 "../src/Services/UserManager.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 217 "../src/Services/UserManager.vala"
			userbox = (SessionWidgetsUserbox*) _tmp8_;
#line 218 "../src/Services/UserManager.vala"
			_tmp9_ = userbox;
#line 218 "../src/Services/UserManager.vala"
			session_widgets_userbox_update_state (_tmp9_, NULL, NULL);
#line 217 "../src/Services/UserManager.vala"
			_g_object_unref0 (userbox);
#line 1534 "UserManager.c"
		}
#line 217 "../src/Services/UserManager.vala"
		_g_object_unref0 (_userbox_it);
#line 1538 "UserManager.c"
	}
}

static void
session_services_user_manager_add_guest (SessionServicesUserManager* self)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SessionWidgetsUserbox* _tmp2_;
	gboolean _tmp3_;
	GeeHashMap* _tmp4_;
	SessionWidgetsUserbox* _tmp5_;
	SessionWidgetsUserbox* _tmp6_;
	GeeHashMap* _tmp7_;
	gpointer _tmp8_;
	SessionWidgetsUserbox* _tmp9_;
	SessionWidgetsUserListBox* _tmp10_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	SessionWidgetsUserbox* _tmp13_;
#line 222 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/Services/UserManager.vala"
	_tmp0_ = self->priv->user_boxes;
#line 223 "../src/Services/UserManager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) SESSION_SERVICES_USER_MANAGER_GUEST_USER_UID));
#line 223 "../src/Services/UserManager.vala"
	_tmp2_ = (SessionWidgetsUserbox*) _tmp1_;
#line 223 "../src/Services/UserManager.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 223 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp2_);
#line 223 "../src/Services/UserManager.vala"
	if (_tmp3_) {
#line 224 "../src/Services/UserManager.vala"
		return;
#line 1575 "UserManager.c"
	}
#line 227 "../src/Services/UserManager.vala"
	_tmp4_ = self->priv->user_boxes;
#line 227 "../src/Services/UserManager.vala"
	_tmp5_ = session_widgets_userbox_new_guest ();
#line 227 "../src/Services/UserManager.vala"
	g_object_ref_sink (_tmp5_);
#line 227 "../src/Services/UserManager.vala"
	_tmp6_ = _tmp5_;
#line 227 "../src/Services/UserManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((guintptr) SESSION_SERVICES_USER_MANAGER_GUEST_USER_UID), _tmp6_);
#line 227 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp6_);
#line 228 "../src/Services/UserManager.vala"
	_tmp7_ = self->priv->user_boxes;
#line 228 "../src/Services/UserManager.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) SESSION_SERVICES_USER_MANAGER_GUEST_USER_UID));
#line 228 "../src/Services/UserManager.vala"
	_tmp9_ = (SessionWidgetsUserbox*) _tmp8_;
#line 228 "../src/Services/UserManager.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 228 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp9_);
#line 230 "../src/Services/UserManager.vala"
	_tmp10_ = self->priv->_user_grid;
#line 230 "../src/Services/UserManager.vala"
	_tmp11_ = self->priv->user_boxes;
#line 230 "../src/Services/UserManager.vala"
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (gpointer) ((guintptr) SESSION_SERVICES_USER_MANAGER_GUEST_USER_UID));
#line 230 "../src/Services/UserManager.vala"
	_tmp13_ = (SessionWidgetsUserbox*) _tmp12_;
#line 230 "../src/Services/UserManager.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp13_);
#line 230 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp13_);
#line 1611 "UserManager.c"
}

static void
session_services_user_manager_get_n_active_and_online_users_data_free (gpointer _data)
{
	SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_;
	_data_ = _data;
#line 37 "../src/Services/UserManager.vala"
	_g_object_unref0 (_data_->self);
#line 37 "../src/Services/UserManager.vala"
	g_slice_free (SessionServicesUserManagerGetNActiveAndOnlineUsersData, _data_);
#line 1623 "UserManager.c"
}

void
session_services_user_manager_get_n_active_and_online_users (SessionServicesUserManager* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_)
{
	SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_;
	SessionServicesUserManager* _tmp0_;
#line 37 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_slice_new0 (SessionServicesUserManagerGetNActiveAndOnlineUsersData);
#line 37 "../src/Services/UserManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 37 "../src/Services/UserManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_services_user_manager_get_n_active_and_online_users_data_free);
#line 37 "../src/Services/UserManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 37 "../src/Services/UserManager.vala"
	_data_->self = _tmp0_;
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_get_n_active_and_online_users_co (_data_);
#line 1647 "UserManager.c"
}

gint
session_services_user_manager_get_n_active_and_online_users_finish (SessionServicesUserManager* self,
                                                                    GAsyncResult* _res_)
{
	gint result;
	SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_;
#line 37 "../src/Services/UserManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 37 "../src/Services/UserManager.vala"
	result = _data_->result;
#line 37 "../src/Services/UserManager.vala"
	return result;
#line 1662 "UserManager.c"
}

static void
session_services_user_manager_get_n_active_and_online_users_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_)
{
	SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_;
#line 248 "../src/Services/UserManager.vala"
	_data_ = _user_data_;
#line 248 "../src/Services/UserManager.vala"
	_data_->_source_object_ = source_object;
#line 248 "../src/Services/UserManager.vala"
	_data_->_res_ = _res_;
#line 248 "../src/Services/UserManager.vala"
	session_services_user_manager_get_n_active_and_online_users_co (_data_);
#line 1679 "UserManager.c"
}

static gboolean
session_services_user_manager_get_n_active_and_online_users_co (SessionServicesUserManagerGetNActiveAndOnlineUsersData* _data_)
{
#line 234 "../src/Services/UserManager.vala"
	switch (_data_->_state_) {
#line 234 "../src/Services/UserManager.vala"
		case 0:
#line 1689 "UserManager.c"
		goto _state_0;
#line 234 "../src/Services/UserManager.vala"
		case 1:
#line 1693 "UserManager.c"
		goto _state_1;
		default:
#line 234 "../src/Services/UserManager.vala"
		g_assert_not_reached ();
#line 1698 "UserManager.c"
	}
	_state_0:
#line 235 "../src/Services/UserManager.vala"
	_data_->n_active_and_online_users = 0;
#line 237 "../src/Services/UserManager.vala"
	_data_->_tmp0_ = _data_->self->priv->manager;
#line 237 "../src/Services/UserManager.vala"
	g_object_get (_data_->_tmp0_, "is-loaded", &_data_->_tmp1_, NULL);
#line 237 "../src/Services/UserManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 237 "../src/Services/UserManager.vala"
	if (!_data_->_tmp2_) {
#line 238 "../src/Services/UserManager.vala"
		g_critical ("UserManager.vala:238: UserManager not yet loaded");
#line 239 "../src/Services/UserManager.vala"
		_data_->result = _data_->n_active_and_online_users;
#line 239 "../src/Services/UserManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 239 "../src/Services/UserManager.vala"
		if (_data_->_state_ != 0) {
#line 239 "../src/Services/UserManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 239 "../src/Services/UserManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1723 "UserManager.c"
			}
		}
#line 239 "../src/Services/UserManager.vala"
		g_object_unref (_data_->_async_result);
#line 239 "../src/Services/UserManager.vala"
		return FALSE;
#line 1730 "UserManager.c"
	}
#line 242 "../src/Services/UserManager.vala"
	_data_->_tmp3_ = _data_->self->priv->manager;
#line 242 "../src/Services/UserManager.vala"
	_data_->_tmp4_ = act_user_manager_list_users (_data_->_tmp3_);
#line 1736 "UserManager.c"
	{
#line 242 "../src/Services/UserManager.vala"
		_data_->user_collection = _data_->_tmp4_;
#line 242 "../src/Services/UserManager.vala"
		for (_data_->user_it = _data_->user_collection; _data_->user_it != NULL; _data_->user_it = _data_->user_it->next) {
#line 242 "../src/Services/UserManager.vala"
			_data_->user = (ActUser*) _data_->user_it->data;
#line 1744 "UserManager.c"
			{
#line 244 "../src/Services/UserManager.vala"
				_data_->_tmp6_ = _data_->user;
#line 244 "../src/Services/UserManager.vala"
				_data_->_tmp7_ = act_user_get_uid (_data_->_tmp6_);
#line 244 "../src/Services/UserManager.vala"
				_data_->_tmp8_ = _data_->_tmp7_;
#line 244 "../src/Services/UserManager.vala"
				if (((guint) _data_->_tmp8_) < SESSION_SERVICES_USER_MANAGER_RESERVED_UID_RANGE_END) {
#line 244 "../src/Services/UserManager.vala"
					_data_->_tmp5_ = TRUE;
#line 1756 "UserManager.c"
				} else {
#line 244 "../src/Services/UserManager.vala"
					_data_->_tmp9_ = _data_->user;
#line 244 "../src/Services/UserManager.vala"
					_data_->_tmp10_ = act_user_get_uid (_data_->_tmp9_);
#line 244 "../src/Services/UserManager.vala"
					_data_->_tmp11_ = _data_->_tmp10_;
#line 244 "../src/Services/UserManager.vala"
					_data_->_tmp5_ = ((guint) _data_->_tmp11_) == SESSION_SERVICES_USER_MANAGER_NOBODY_USER_UID;
#line 1766 "UserManager.c"
				}
#line 244 "../src/Services/UserManager.vala"
				if (_data_->_tmp5_) {
#line 245 "../src/Services/UserManager.vala"
					continue;
#line 1772 "UserManager.c"
				}
#line 248 "../src/Services/UserManager.vala"
				_data_->_tmp12_ = _data_->user;
#line 248 "../src/Services/UserManager.vala"
				_data_->_tmp13_ = act_user_get_uid (_data_->_tmp12_);
#line 248 "../src/Services/UserManager.vala"
				_data_->_tmp14_ = _data_->_tmp13_;
#line 248 "../src/Services/UserManager.vala"
				_data_->_state_ = 1;
#line 248 "../src/Services/UserManager.vala"
				session_services_user_manager_get_user_state ((guint32) _data_->_tmp14_, session_services_user_manager_get_n_active_and_online_users_ready, _data_);
#line 248 "../src/Services/UserManager.vala"
				return FALSE;
#line 1786 "UserManager.c"
				_state_1:
#line 248 "../src/Services/UserManager.vala"
				_data_->state = session_services_user_manager_get_user_state_finish (_data_->_res_);
#line 256 "../src/Services/UserManager.vala"
				if (_data_->state == USER_STATE_ACTIVE) {
#line 256 "../src/Services/UserManager.vala"
					_data_->_tmp15_ = TRUE;
#line 1794 "UserManager.c"
				} else {
#line 256 "../src/Services/UserManager.vala"
					_data_->_tmp15_ = _data_->state == USER_STATE_ONLINE;
#line 1798 "UserManager.c"
				}
#line 256 "../src/Services/UserManager.vala"
				if (_data_->_tmp15_) {
#line 257 "../src/Services/UserManager.vala"
					_data_->_tmp16_ = _data_->n_active_and_online_users;
#line 257 "../src/Services/UserManager.vala"
					_data_->n_active_and_online_users = _data_->_tmp16_ + 1;
#line 1806 "UserManager.c"
				}
			}
		}
#line 242 "../src/Services/UserManager.vala"
		(_data_->user_collection == NULL) ? NULL : (_data_->user_collection = (g_slist_free (_data_->user_collection), NULL));
#line 1812 "UserManager.c"
	}
#line 261 "../src/Services/UserManager.vala"
	_data_->result = _data_->n_active_and_online_users;
#line 261 "../src/Services/UserManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 261 "../src/Services/UserManager.vala"
	if (_data_->_state_ != 0) {
#line 261 "../src/Services/UserManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 261 "../src/Services/UserManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1824 "UserManager.c"
		}
	}
#line 261 "../src/Services/UserManager.vala"
	g_object_unref (_data_->_async_result);
#line 261 "../src/Services/UserManager.vala"
	return FALSE;
#line 1831 "UserManager.c"
}

SessionServicesUserManager*
session_services_user_manager_construct (GType object_type)
{
	SessionServicesUserManager * self = NULL;
#line 37 "../src/Services/UserManager.vala"
	self = (SessionServicesUserManager*) g_object_new (object_type, NULL);
#line 37 "../src/Services/UserManager.vala"
	return self;
#line 1842 "UserManager.c"
}

SessionServicesUserManager*
session_services_user_manager_new (void)
{
#line 37 "../src/Services/UserManager.vala"
	return session_services_user_manager_construct (SESSION_SERVICES_TYPE_USER_MANAGER);
#line 1850 "UserManager.c"
}

SessionWidgetsUserListBox*
session_services_user_manager_get_user_grid (SessionServicesUserManager* self)
{
	SessionWidgetsUserListBox* result;
	SessionWidgetsUserListBox* _tmp0_;
#line 41 "../src/Services/UserManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Services/UserManager.vala"
	_tmp0_ = self->priv->_user_grid;
#line 41 "../src/Services/UserManager.vala"
	result = _tmp0_;
#line 41 "../src/Services/UserManager.vala"
	return result;
#line 1866 "UserManager.c"
}

static void
session_services_user_manager_set_user_grid (SessionServicesUserManager* self,
                                             SessionWidgetsUserListBox* value)
{
	SessionWidgetsUserListBox* old_value;
#line 41 "../src/Services/UserManager.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Services/UserManager.vala"
	old_value = session_services_user_manager_get_user_grid (self);
#line 41 "../src/Services/UserManager.vala"
	if (old_value != value) {
#line 1880 "UserManager.c"
		SessionWidgetsUserListBox* _tmp0_;
#line 41 "../src/Services/UserManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/Services/UserManager.vala"
		_g_object_unref0 (self->priv->_user_grid);
#line 41 "../src/Services/UserManager.vala"
		self->priv->_user_grid = _tmp0_;
#line 41 "../src/Services/UserManager.vala"
		g_object_notify_by_pspec ((GObject *) self, session_services_user_manager_properties[SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY]);
#line 1890 "UserManager.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 121 "../src/Services/UserManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 121 "../src/Services/UserManager.vala"
	return _data4_;
#line 1901 "UserManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 121 "../src/Services/UserManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1911 "UserManager.c"
		SessionServicesUserManager* self;
#line 121 "../src/Services/UserManager.vala"
		self = _data4_->self;
#line 121 "../src/Services/UserManager.vala"
		_g_free0 (_data4_->session_path);
#line 121 "../src/Services/UserManager.vala"
		_g_object_unref0 (self);
#line 121 "../src/Services/UserManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 1921 "UserManager.c"
	}
}

static void
_session_services_user_manager___lambda5_ (SessionServicesUserManager* self)
{
#line 125 "../src/Services/UserManager.vala"
	g_signal_emit (self, session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CLOSE_SIGNAL], 0);
#line 1930 "UserManager.c"
}

static void
__session_services_user_manager___lambda5__session_widgets_user_list_box_close (SessionWidgetsUserListBox* _sender,
                                                                                gpointer self)
{
#line 125 "../src/Services/UserManager.vala"
	_session_services_user_manager___lambda5_ ((SessionServicesUserManager*) self);
#line 1939 "UserManager.c"
}

static void
_session_services_user_manager_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self)
{
#line 130 "../src/Services/UserManager.vala"
	session_services_user_manager_add_user ((SessionServicesUserManager*) self, user);
#line 1949 "UserManager.c"
}

static void
_session_services_user_manager_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self)
{
#line 131 "../src/Services/UserManager.vala"
	session_services_user_manager_remove_user ((SessionServicesUserManager*) self, user);
#line 1959 "UserManager.c"
}

static void
_session_services_user_manager_update_user_act_user_manager_user_is_logged_in_changed (ActUserManager* _sender,
                                                                                       ActUser* user,
                                                                                       gpointer self)
{
#line 132 "../src/Services/UserManager.vala"
	session_services_user_manager_update_user ((SessionServicesUserManager*) self, user);
#line 1969 "UserManager.c"
}

static void
_session_services_user_manager___lambda6_ (SessionServicesUserManager* self)
{
#line 135 "../src/Services/UserManager.vala"
	session_services_user_manager_init_users (self);
#line 1977 "UserManager.c"
}

static void
__session_services_user_manager___lambda6__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 134 "../src/Services/UserManager.vala"
	_session_services_user_manager___lambda6_ ((SessionServicesUserManager*) self);
#line 1987 "UserManager.c"
}

static void
_session_services_user_manager____lambda7_ (SessionServicesUserManager* self)
{
	GError* _inner_error0_ = NULL;
	{
		SeatInterface* _tmp0_;
#line 155 "../src/Services/UserManager.vala"
		_tmp0_ = self->priv->dm_proxy;
#line 155 "../src/Services/UserManager.vala"
		seat_interface_switch_to_guest (_tmp0_, "", &_inner_error0_);
#line 155 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2002 "UserManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 154 "../src/Services/UserManager.vala"
		e = _inner_error0_;
#line 154 "../src/Services/UserManager.vala"
		_inner_error0_ = NULL;
#line 157 "../src/Services/UserManager.vala"
		_tmp1_ = e;
#line 157 "../src/Services/UserManager.vala"
		_tmp2_ = _tmp1_->message;
#line 157 "../src/Services/UserManager.vala"
		g_warning ("UserManager.vala:157: Error switching to guest account: %s", _tmp2_);
#line 154 "../src/Services/UserManager.vala"
		_g_error_free0 (e);
#line 2024 "UserManager.c"
	}
	__finally0:
#line 154 "../src/Services/UserManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/Services/UserManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/Services/UserManager.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/Services/UserManager.vala"
		return;
#line 2035 "UserManager.c"
	}
}

static void
__session_services_user_manager____lambda7__session_widgets_user_list_box_switch_to_guest (SessionWidgetsUserListBox* _sender,
                                                                                           gpointer self)
{
#line 153 "../src/Services/UserManager.vala"
	_session_services_user_manager____lambda7_ ((SessionServicesUserManager*) self);
#line 2045 "UserManager.c"
}

static void
_session_services_user_manager____lambda8_ (Block4Data* _data4_,
                                            const gchar* username)
{
	SessionServicesUserManager* self;
	GError* _inner_error0_ = NULL;
#line 161 "../src/Services/UserManager.vala"
	self = _data4_->self;
#line 161 "../src/Services/UserManager.vala"
	g_return_if_fail (username != NULL);
#line 2058 "UserManager.c"
	{
		SeatInterface* _tmp0_;
		const gchar* _tmp1_;
#line 163 "../src/Services/UserManager.vala"
		_tmp0_ = self->priv->dm_proxy;
#line 163 "../src/Services/UserManager.vala"
		_tmp1_ = _data4_->session_path;
#line 163 "../src/Services/UserManager.vala"
		seat_interface_switch_to_user (_tmp0_, username, _tmp1_, &_inner_error0_);
#line 163 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2070 "UserManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 162 "../src/Services/UserManager.vala"
		e = _inner_error0_;
#line 162 "../src/Services/UserManager.vala"
		_inner_error0_ = NULL;
#line 165 "../src/Services/UserManager.vala"
		_tmp2_ = e;
#line 165 "../src/Services/UserManager.vala"
		_tmp3_ = _tmp2_->message;
#line 165 "../src/Services/UserManager.vala"
		g_warning ("UserManager.vala:165: Error switching to user '%s': %s", username, _tmp3_);
#line 162 "../src/Services/UserManager.vala"
		_g_error_free0 (e);
#line 2092 "UserManager.c"
	}
	__finally0:
#line 162 "../src/Services/UserManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../src/Services/UserManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/Services/UserManager.vala"
		g_clear_error (&_inner_error0_);
#line 162 "../src/Services/UserManager.vala"
		return;
#line 2103 "UserManager.c"
	}
}

static void
__session_services_user_manager____lambda8__session_widgets_user_list_box_switch_to_user (SessionWidgetsUserListBox* _sender,
                                                                                          const gchar* username,
                                                                                          gpointer self)
{
#line 161 "../src/Services/UserManager.vala"
	_session_services_user_manager____lambda8_ (self, username);
#line 2114 "UserManager.c"
}

static GObject *
session_services_user_manager_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SessionServicesUserManager * self;
	Block4Data* _data4_;
	GeeHashMap* _tmp0_;
	SessionWidgetsUserListBox* _tmp1_;
	SessionWidgetsUserListBox* _tmp2_;
	SessionWidgetsUserListBox* _tmp3_;
	ActUserManager* _tmp4_;
	ActUserManager* _tmp5_;
	ActUserManager* _tmp6_;
	ActUserManager* _tmp7_;
	ActUserManager* _tmp8_;
	ActUserManager* _tmp9_;
	gchar* seat_path = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	SeatInterface* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 121 "../src/Services/UserManager.vala"
	parent_class = G_OBJECT_CLASS (session_services_user_manager_parent_class);
#line 121 "../src/Services/UserManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 121 "../src/Services/UserManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SESSION_SERVICES_TYPE_USER_MANAGER, SessionServicesUserManager);
#line 121 "../src/Services/UserManager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 121 "../src/Services/UserManager.vala"
	_data4_->_ref_count_ = 1;
#line 121 "../src/Services/UserManager.vala"
	_data4_->self = g_object_ref (self);
#line 122 "../src/Services/UserManager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SESSION_WIDGETS_TYPE_USERBOX, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 122 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->user_boxes);
#line 122 "../src/Services/UserManager.vala"
	self->priv->user_boxes = _tmp0_;
#line 124 "../src/Services/UserManager.vala"
	_tmp1_ = session_widgets_user_list_box_new ();
#line 124 "../src/Services/UserManager.vala"
	g_object_ref_sink (_tmp1_);
#line 124 "../src/Services/UserManager.vala"
	_tmp2_ = _tmp1_;
#line 124 "../src/Services/UserManager.vala"
	session_services_user_manager_set_user_grid (self, _tmp2_);
#line 124 "../src/Services/UserManager.vala"
	_g_object_unref0 (_tmp2_);
#line 125 "../src/Services/UserManager.vala"
	_tmp3_ = self->priv->_user_grid;
#line 125 "../src/Services/UserManager.vala"
	g_signal_connect_object (_tmp3_, "close", (GCallback) __session_services_user_manager___lambda5__session_widgets_user_list_box_close, self, 0);
#line 127 "../src/Services/UserManager.vala"
	_tmp4_ = act_user_manager_get_default ();
#line 127 "../src/Services/UserManager.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 127 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->manager);
#line 127 "../src/Services/UserManager.vala"
	self->priv->manager = _tmp5_;
#line 128 "../src/Services/UserManager.vala"
	session_services_user_manager_init_users (self);
#line 130 "../src/Services/UserManager.vala"
	_tmp6_ = self->priv->manager;
#line 130 "../src/Services/UserManager.vala"
	g_signal_connect_object (_tmp6_, "user-added", (GCallback) _session_services_user_manager_add_user_act_user_manager_user_added, self, 0);
#line 131 "../src/Services/UserManager.vala"
	_tmp7_ = self->priv->manager;
#line 131 "../src/Services/UserManager.vala"
	g_signal_connect_object (_tmp7_, "user-removed", (GCallback) _session_services_user_manager_remove_user_act_user_manager_user_removed, self, 0);
#line 132 "../src/Services/UserManager.vala"
	_tmp8_ = self->priv->manager;
#line 132 "../src/Services/UserManager.vala"
	g_signal_connect_object (_tmp8_, "user-is-logged-in-changed", (GCallback) _session_services_user_manager_update_user_act_user_manager_user_is_logged_in_changed, self, 0);
#line 134 "../src/Services/UserManager.vala"
	_tmp9_ = self->priv->manager;
#line 134 "../src/Services/UserManager.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::is-loaded", (GCallback) __session_services_user_manager___lambda6__g_object_notify, self, 0);
#line 138 "../src/Services/UserManager.vala"
	_tmp10_ = g_getenv ("XDG_SEAT_PATH");
#line 138 "../src/Services/UserManager.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 138 "../src/Services/UserManager.vala"
	seat_path = _tmp11_;
#line 139 "../src/Services/UserManager.vala"
	_tmp12_ = g_getenv ("XDG_SESSION_PATH");
#line 139 "../src/Services/UserManager.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 139 "../src/Services/UserManager.vala"
	_data4_->session_path = _tmp13_;
#line 141 "../src/Services/UserManager.vala"
	_tmp14_ = seat_path;
#line 141 "../src/Services/UserManager.vala"
	if (_tmp14_ != NULL) {
#line 2218 "UserManager.c"
		{
			SeatInterface* _tmp15_ = NULL;
			const gchar* _tmp16_;
			SeatInterface* _tmp17_;
			SeatInterface* _tmp18_;
			SeatInterface* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp21_;
#line 143 "../src/Services/UserManager.vala"
			_tmp16_ = seat_path;
#line 143 "../src/Services/UserManager.vala"
			_tmp17_ = (SeatInterface*) g_initable_new (TYPE_SEAT_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", SESSION_SERVICES_USER_MANAGER_DM_DBUS_ID, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp16_, "g-interface-name", "org.freedesktop.DisplayManager.Seat", NULL);
#line 143 "../src/Services/UserManager.vala"
			_tmp15_ = (SeatInterface*) _tmp17_;
#line 143 "../src/Services/UserManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/Services/UserManager.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 2237 "UserManager.c"
					goto __catch0_g_io_error;
				}
#line 143 "../src/Services/UserManager.vala"
				_g_free0 (seat_path);
#line 143 "../src/Services/UserManager.vala"
				block4_data_unref (_data4_);
#line 143 "../src/Services/UserManager.vala"
				_data4_ = NULL;
#line 143 "../src/Services/UserManager.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/Services/UserManager.vala"
				g_clear_error (&_inner_error0_);
#line 2250 "UserManager.c"
			}
#line 143 "../src/Services/UserManager.vala"
			_tmp18_ = _tmp15_;
#line 143 "../src/Services/UserManager.vala"
			_tmp15_ = NULL;
#line 143 "../src/Services/UserManager.vala"
			_g_object_unref0 (self->priv->dm_proxy);
#line 143 "../src/Services/UserManager.vala"
			self->priv->dm_proxy = _tmp18_;
#line 144 "../src/Services/UserManager.vala"
			_tmp19_ = self->priv->dm_proxy;
#line 144 "../src/Services/UserManager.vala"
			_tmp20_ = seat_interface_get_has_guest_account (_tmp19_);
#line 144 "../src/Services/UserManager.vala"
			_tmp21_ = _tmp20_;
#line 144 "../src/Services/UserManager.vala"
			if (_tmp21_) {
#line 145 "../src/Services/UserManager.vala"
				session_services_user_manager_add_guest (self);
#line 2270 "UserManager.c"
			}
#line 142 "../src/Services/UserManager.vala"
			_g_object_unref0 (_tmp15_);
#line 2274 "UserManager.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp22_;
			const gchar* _tmp23_;
#line 142 "../src/Services/UserManager.vala"
			e = _inner_error0_;
#line 142 "../src/Services/UserManager.vala"
			_inner_error0_ = NULL;
#line 148 "../src/Services/UserManager.vala"
			_tmp22_ = e;
#line 148 "../src/Services/UserManager.vala"
			_tmp23_ = _tmp22_->message;
#line 148 "../src/Services/UserManager.vala"
			g_critical ("UserManager.vala:148: UserManager error: %s", _tmp23_);
#line 142 "../src/Services/UserManager.vala"
			_g_error_free0 (e);
#line 2294 "UserManager.c"
		}
		__finally0:
#line 142 "../src/Services/UserManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/Services/UserManager.vala"
			_g_free0 (seat_path);
#line 142 "../src/Services/UserManager.vala"
			block4_data_unref (_data4_);
#line 142 "../src/Services/UserManager.vala"
			_data4_ = NULL;
#line 142 "../src/Services/UserManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/Services/UserManager.vala"
			g_clear_error (&_inner_error0_);
#line 2309 "UserManager.c"
		}
	}
#line 152 "../src/Services/UserManager.vala"
	_tmp24_ = self->priv->dm_proxy;
#line 152 "../src/Services/UserManager.vala"
	if (_tmp24_ != NULL) {
#line 2316 "UserManager.c"
		SessionWidgetsUserListBox* _tmp25_;
		SessionWidgetsUserListBox* _tmp26_;
#line 153 "../src/Services/UserManager.vala"
		_tmp25_ = self->priv->_user_grid;
#line 153 "../src/Services/UserManager.vala"
		g_signal_connect_object (_tmp25_, "switch-to-guest", (GCallback) __session_services_user_manager____lambda7__session_widgets_user_list_box_switch_to_guest, self, 0);
#line 161 "../src/Services/UserManager.vala"
		_tmp26_ = self->priv->_user_grid;
#line 161 "../src/Services/UserManager.vala"
		g_signal_connect_data (_tmp26_, "switch-to-user", (GCallback) __session_services_user_manager____lambda8__session_widgets_user_list_box_switch_to_user, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 2327 "UserManager.c"
	}
#line 121 "../src/Services/UserManager.vala"
	_g_free0 (seat_path);
#line 121 "../src/Services/UserManager.vala"
	block4_data_unref (_data4_);
#line 121 "../src/Services/UserManager.vala"
	_data4_ = NULL;
#line 121 "../src/Services/UserManager.vala"
	return obj;
#line 2337 "UserManager.c"
}

static void
session_services_user_manager_class_init (SessionServicesUserManagerClass * klass,
                                          gpointer klass_data)
{
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/Services/UserManager.vala"
	g_type_class_adjust_private_offset (klass, &SessionServicesUserManager_private_offset);
#line 37 "../src/Services/UserManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_session_services_user_manager_get_property;
#line 37 "../src/Services/UserManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_session_services_user_manager_set_property;
#line 37 "../src/Services/UserManager.vala"
	G_OBJECT_CLASS (klass)->constructor = session_services_user_manager_constructor;
#line 37 "../src/Services/UserManager.vala"
	G_OBJECT_CLASS (klass)->finalize = session_services_user_manager_finalize;
#line 37 "../src/Services/UserManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY, session_services_user_manager_properties[SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY] = g_param_spec_object ("user-grid", "user-grid", "user-grid", SESSION_WIDGETS_TYPE_USER_LIST_BOX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CLOSE_SIGNAL] = g_signal_new ("close", SESSION_SERVICES_TYPE_USER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 37 "../src/Services/UserManager.vala"
	session_services_user_manager_signals[SESSION_SERVICES_USER_MANAGER_CHANGED_SIGNAL] = g_signal_new ("changed", SESSION_SERVICES_TYPE_USER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 58 "../src/Services/UserManager.vala"
	session_services_user_manager_init_login_proxy (NULL, NULL);
#line 2364 "UserManager.c"
}

static void
session_services_user_manager_instance_init (SessionServicesUserManager * self,
                                             gpointer klass)
{
#line 37 "../src/Services/UserManager.vala"
	self->priv = session_services_user_manager_get_instance_private (self);
#line 53 "../src/Services/UserManager.vala"
	self->priv->dm_proxy = NULL;
#line 2375 "UserManager.c"
}

static void
session_services_user_manager_finalize (GObject * obj)
{
	SessionServicesUserManager * self;
#line 37 "../src/Services/UserManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SESSION_SERVICES_TYPE_USER_MANAGER, SessionServicesUserManager);
#line 41 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->_user_grid);
#line 51 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->manager);
#line 52 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->user_boxes);
#line 53 "../src/Services/UserManager.vala"
	_g_object_unref0 (self->priv->dm_proxy);
#line 37 "../src/Services/UserManager.vala"
	G_OBJECT_CLASS (session_services_user_manager_parent_class)->finalize (obj);
#line 2394 "UserManager.c"
}

static GType
session_services_user_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SessionServicesUserManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) session_services_user_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SessionServicesUserManager), 0, (GInstanceInitFunc) session_services_user_manager_instance_init, NULL };
	GType session_services_user_manager_type_id;
	session_services_user_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SessionServicesUserManager", &g_define_type_info, 0);
	SessionServicesUserManager_private_offset = g_type_add_instance_private (session_services_user_manager_type_id, sizeof (SessionServicesUserManagerPrivate));
	return session_services_user_manager_type_id;
}

GType
session_services_user_manager_get_type (void)
{
	static volatile gsize session_services_user_manager_type_id__once = 0;
	if (g_once_init_enter (&session_services_user_manager_type_id__once)) {
		GType session_services_user_manager_type_id;
		session_services_user_manager_type_id = session_services_user_manager_get_type_once ();
		g_once_init_leave (&session_services_user_manager_type_id__once, session_services_user_manager_type_id);
	}
	return session_services_user_manager_type_id__once;
}

static void
_vala_session_services_user_manager_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	SessionServicesUserManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SESSION_SERVICES_TYPE_USER_MANAGER, SessionServicesUserManager);
#line 37 "../src/Services/UserManager.vala"
	switch (property_id) {
#line 37 "../src/Services/UserManager.vala"
		case SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY:
#line 37 "../src/Services/UserManager.vala"
		g_value_set_object (value, session_services_user_manager_get_user_grid (self));
#line 37 "../src/Services/UserManager.vala"
		break;
#line 2435 "UserManager.c"
		default:
#line 37 "../src/Services/UserManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Services/UserManager.vala"
		break;
#line 2441 "UserManager.c"
	}
}

static void
_vala_session_services_user_manager_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	SessionServicesUserManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SESSION_SERVICES_TYPE_USER_MANAGER, SessionServicesUserManager);
#line 37 "../src/Services/UserManager.vala"
	switch (property_id) {
#line 37 "../src/Services/UserManager.vala"
		case SESSION_SERVICES_USER_MANAGER_USER_GRID_PROPERTY:
#line 37 "../src/Services/UserManager.vala"
		session_services_user_manager_set_user_grid (self, g_value_get_object (value));
#line 37 "../src/Services/UserManager.vala"
		break;
#line 2461 "UserManager.c"
		default:
#line 37 "../src/Services/UserManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Services/UserManager.vala"
		break;
#line 2467 "UserManager.c"
	}
}

